#!/bin/bash

###########  station specific details  ##################
#stationlogo=NI135
#timestep=7.5
#datadir=/home/leontiou/rsf/${stationlogo}/
#datadir2=/home/leontiou/rsf/${stationlogo}/processed/

stationlogo=`sed -n '1p' < station.txt`
timestep=`sed -n '2p' < station.txt`
datadir=`sed -n '3p' < station.txt`
datadir2=`sed -n '4p' < station.txt`



HERE=`pwd`
bindir=${HERE}/bin/
mkdir -p $datadir2
dirname=${stationlogo}
logo=${stationlogo}
mkdir -p $dirname
cd $dirname


######### Frequency ranges to be used in the analysis (MHz)
nf=7
cat <<EOF >freq
${nf}
1.0 2.0
2.0 3.0
3.0 4.0
4.0 5.0
5.0 6.0
6.0 7.0
7.0 8.0
EOF
######################################################



msignl=1 
nmaxima=1
rm -f list
touch list
ls -1 ${datadir}/${stationlogo}* >>list
list=list
nfiles=`wc -l list | cut -c 1-3`
echo "found" ${nfiles} "files in directory" $datadir


cat <<EOF >input
${logo}   :: logo
${list}   :: listname -> list of RSF files (full path!)
$timestep       :: timestep (minutes)
EOF
cat freq >> input
cat <<EOF >> input
3         :: jmode -> Xmode(1), Omode(2), combined(3)
$msignl   :: msignl!  if(msignl.eq.0)amp=amp-mps
1         :: mscale !if(mscale.eq.0)amp=1. !just count echoes (but weight by gain)
220. 400. :: minh ; maxh 
6         :: avh (for averaging the heights)
${nmaxima} :: nmaxima;
EOF


HERE=`pwd`

rm -f ${logo}_maxima_?.dat
#gfortran -o ${bindir}/readRSF.out ${bindir}/readRSF.f90
${bindir}/readRSF.out | tee output_${logo}
rm -f list
rm -f freq
rm -f input

if [ -f ${logo}_maxima_1.dat ]; then

append=1
if [ $append -eq 1 ]; then

#gfortran -o ${bindir}/append.out ${bindir}/append.f90
i=1
while [ $i -le $nf ];
do
cat <<EOF >input_append
${logo}_collectedmaxima_${i}.dat
${logo}_maxima_${i}.dat
EOF
${bindir}/append.out <input_append
let i++
done
rm -f input_append
fi

mv ${datadir}/${stationlogo}* ${datadir2}/

else

echo "No data collected" 
    
fi
