  implicit none
  integer ndata,n,i,j,icase
  character*100 :: fname1,fname2 ! append data from fname1 to fname2

  type datum
     integer :: year,day,hour,minute
     double precision :: t,x,dx
     real :: timestep
  end type datum
  type(datum), allocatable :: data(:)
  type(datum) :: point

  read(*,*)fname2
  print*,'read '//trim(fname2)
  open(1,file=trim(fname2))  
  call load_data()
  close(1)
  
  print*,'enter filename 1'
  read(*,*)fname1
  print*,'read '//trim(fname1)
  open(1,file=trim(fname1),status='old',action='read',err=800)
  n=0
  do
     read(1,*,end=100)
     n=n+1
  end do
100 continue
  rewind(1)

  if(ndata==0)then
     allocate(data(n))
     do i=1,n
        read(1,*)point%year,point%day,point%hour,point%minute,point%t,point%x,point%dx,point%timestep
        data(i)=point
     end do
     ndata=n
  else
  
  do i=1,n
     read(1,*)point%year,point%day,point%hour,point%minute,point%t,point%x,point%dx,point%timestep
     if(point%year==0 .and. point%day==0)cycle
     icase=0 ! new point is 
!!$     do j=1,ndata ! chech if same time instand exisists already
!!$        if(data(j)%year==point%year .and. data(j)%day==point%day .and. &
!!$             data(j)%hour==point%hour .and. data(j)%minute==point%minute )then !same time instant -> just replace
!!$           data(j)=point
!!$           icase=j
!!$        end if
!!$        if(icase.ne.0)exit
!!$     end do
!!$     if(icase.ne.0)cycle !if time instant already present skip the rest
     
     do j=1,ndata
        if(data(j)%year==point%year .and. data(j)%day==point%day .and. &
             data(j)%hour==point%hour .and. data(j)%minute==point%minute )then !same time instant -> just replace
           data(j)=point
           icase=-1
        end if
        if(icase.ne.0)exit

        if(data(j)%year==point%year .and. data(j)%day==point%day .and. &
             data(j)%hour==point%hour .and. data(j)%minute.gt.point%minute )then ! same day and hour but missing minute -> append
           icase=j
        end if
        if(icase.ne.0)exit

        if(data(j)%year==point%year .and. data(j)%day==point%day & ! mising hour
             .and. data(j)%hour.gt.point%hour)then
           icase=j
        end if
        if(icase.ne.0)exit

        if(data(j)%year==point%year .and. data(j)%day.gt.point%day)then
           icase=j
        end if
        if(icase.ne.0)exit

        if(data(j)%year.gt.point%year)then
           icase=j
        end if
        if(icase.ne.0)exit
        
     end do

     if(icase==0)call append_data(ndata+1)
     if(icase.ge.1)call append_data(icase)
  end do
  close(1)

  endif
  
  open(1,file=trim(fname2))
  do i=1,ndata
     if(data(i)%year==0 .and. data(i)%day==0)cycle
     write(1,*)data(i)%year,data(i)%day,data(i)%hour,data(i)%minute,data(i)%t,data(i)%x,data(i)%dx,data(i)%timestep
  end do
  close(1)
  
  goto 1000

800 continue
  print*,'error opening file '//trim(fname1)
  goto 1000

900 continue
  print*,'error opening file '//trim(fname2)
  goto 1000


1000 continue
  
  deallocate(data)
  
CONTAINS

  subroutine load_data()
    implicit none
    integer i
    ndata=0
    do
       read(1,*,end=200)
       ndata=ndata+1
    end do
200 continue
    if(ndata==0)return
    rewind(1)
    allocate (data(ndata))
    do i=1,ndata
       read(1,*)data(i)%year,data(i)%day,data(i)%hour,data(i)%minute,data(i)%t,data(i)%x,data(i)%dx,data(i)%timestep
    end do    
  end subroutine load_data

  subroutine append_data(ip)
    implicit none
    integer, intent(in) :: ip
    type(datum), allocatable :: temp(:)
    integer :: i
    allocate(temp(ndata+1))
    if(ip==ndata+1)then
       do i=1,ndata
          temp(i)=data(i)
       end do
       temp(ndata+1)=point
    else
       do i=1,ip-1
          temp(i)=data(i)
       end do
       temp(ip)=point
       do i=ip+1,ndata+1
          temp(i)=data(i-1)
       end do
    end if
    ndata=ndata+1
    deallocate(data)
    allocate(data(ndata))
    data=temp
    deallocate(temp)    
  end subroutine append_data
    
  

end program
