program readRSF
  implicit none
  character*100 rsfname,listname,logo
  character*100, allocatable :: names(:)
  character*1 A
  
  integer :: jyear,jday,jmonth,jdaymon,jhour,jmin,jsec
  real :: frq1st,fcstep,frqLst,ffstep,basedb
  integer :: nhts,igain,iamps(512,4),mpvamp(32),nsum,avh
  logical :: finished=.false.,endfile=.false.

  real :: amp,minh,maxh,x
  real :: hstart,hstep
 
  real :: fmhz,mps,gscl

  integer :: i,j,ih,ih2,ios,nfiles
  integer :: yearmin=100000,yearmax=0,monthmin=100,monthmax=0, &
  daymonmin=32,daymonmax=0,hourmin=25,hourmax=-10,minutemin=100, & 
  minutemax=-10,daymin=400,daymax=0,Ly

  integer :: imode,jmode,msignl,mscale

  integer :: it,itt,nt,if,nf,nmaxima,iprint,ndaysav
  real :: timestep
  integer, allocatable :: timearray(:,:)
  double precision, allocatable, dimension(:,:,:) :: bins
  double precision, allocatable :: frange(:,:),maxheights(:,:,:)
  integer, allocatable, dimension(:,:,:) :: ncount

  character*100 meanfile
 
  double precision :: ionothresh,temp

  character*200 binfile

  integer iunit,junit

  
  iunit=10
  junit=11
  open(iunit,file='input',status='old',err=700)
  print*,'enter logo'
  read(iunit,*)logo
  print*,'logo is '//trim(logo)
  print*,'enter filename containing the list of RSf files'
  read(iunit,*)listname
  print*,'opening '//trim(listname)
  open(junit,file=trim(listname),status='old',err=800)
  nfiles=0
  do
     read(junit,'(A100)',end=10)rsfname
     nfiles=nfiles+1
  end do
10 continue
  print*,'number of files=',nfiles
  if(nfiles==0)then
     print*,'list is empty'
     close(iunit)
     close(junit)
     goto 1000
  end if
  rewind(junit)
  allocate(names(nfiles))
  do i=1,nfiles
     read(junit,'(A100)',end=10)rsfname
     names(i)=rsfname
  end do
  close(junit)

  
!!!!! read all RSF file headers in order to get time-line
!!!! get minimum and maximum time points
  do i=1,nfiles
     open(junit,file=trim(names(i)),form='unformatted',status='old',access='stream',err=870,iostat=ios)
     call read_header(junit,0)
     if(jyear.lt.yearmin)yearmin=jyear
     if(jyear.gt.yearmax)yearmax=jyear
     close(junit)
     !print*,'read '//trim(names(i))
  end do
  !print*,'hstart,nhts,hstep=',hstart,nhts,hstep
  !hstep2=hstep   !this is the sampling step
  !print*,'sampling step for heights',hstep2  
  !nhts2=(abs(hstart)+(nhts-1)*hstep)/real(hstep2)
  !if(nhts2.gt.nhts)then
  !   print*,'ERROR! too many heights',nhts,nhts2
  !   stop
  !end if
  do i=1,nfiles
     open(junit,file=trim(names(i)),form='unformatted',status='old',access='stream',err=870,iostat=ios)
     call read_header(junit,0)
     if(jyear==yearmin)then
        if(jday.lt.daymin)daymin=jday
     end if
     if(jyear==yearmax)then
        if(jday.gt.daymax)daymax=jday
     end if
     close(junit)
  end do
  print*,'daymin, daymax:',daymin,daymax
  !stop
  do i=1,nfiles
     open(junit,file=trim(names(i)),form='unformatted',status='old',access='stream',err=870,iostat=ios)
     call read_header(junit,0)
     if(jyear==yearmin.and.jday==daymin)then
        if(jhour.lt.hourmin)hourmin=jhour
     end if
     if(jyear==yearmax.and.jday==daymax)then
        if(jhour.gt.hourmax)hourmax=jhour
     end if
     close(junit)
  end do
  print*,'hourmin, hourmax:',hourmin,hourmax
  do i=1,nfiles
     open(junit,file=trim(names(i)),form='unformatted',status='old',access='stream',err=870,iostat=ios)
     call read_header(junit,0)
     if(jyear==yearmin.and.jday==daymin.and.jhour==hourmin)then
        if(jmin.lt.minutemin)minutemin=jmin
     end if
     if(jyear==yearmax.and.jday==daymax.and.jhour==hourmax)then
        if(jmin.gt.minutemax)minutemax=jmin
     end if
     close(junit)
  end do
  print*,'minutemin, minutemax:',minutemin,minutemax

  !goto 1000
  
  Ly=365
  if(mod(yearmin,4).eq.0)Ly=366
  print*,'Ly is ',Ly
  
!!!! define frequency ranges and allocate bins
  print*,'enter timestep in minutes'
  read(iunit,*)timestep
  print*,'read',timestep
  nt=itime(yearmax,daymax,hourmax,minutemax)
  print*,'Start time:',yearmin,daymin,hourmin,minutemin,' time index:',itime(yearmin,daymin,hourmin,minutemin)
  print*,'Stopt time:',yearmax,daymax,hourmax,minutemax,' time index:',itime(yearmax,daymax,hourmax,minutemax)
  print*,'total number of time steps:',nt
  print*,'enter number of frequency bands'
  read(iunit,*)nf

  allocate(bins(nt,nhts,nf),ncount(nt,nhts,nf))
  allocate(timearray(nt,4))
  bins=0.
  ncount=0
  ! frequency ranges
  allocate(frange(nf,2))
  print*,'will sample in the following ranges:'
  do i=1,nf
     read(iunit,*)frange(i,:)
     print*,frange(i,:)
  end do

        
!!!! various input params
  print*,'Xmode(1) or Omode(2) or combined(3)?'
  read(iunit,*)jmode
  print*,'read ',jmode
!  jmode=3
  if(jmode.lt.1.or.jmode.gt.3)then
     print*,' must be 1,2, or 3!'
     stop
  endif
  print*,'enter msignl'
  read(iunit,*)msignl
  print*,'read',msignl
!  msignl=0 !  if(msignl.eq.0)amp=amp-mps
!c.. mps=most prob sig from byte 4 of prelude        
!  mscale=1 !if(mscale.eq.0)amp=1. !just count echoes (but weight by gain)
!  minh=90. ; maxh=400.
  print*,'enter mscale'
  read(iunit,*)mscale
  print*,'read',mscale


!!!! input parameters for sampling
  print*,'enter minh maxh'
  read(iunit,*)minh,maxh
  print*,'read',minh,maxh
  print*,'enter avh'
  read(iunit,*)avh
  print*,'read',avh
  print*,'number of maxima to plot (averaged)'
  read(iunit,*)nmaxima
  print*,'read',nmaxima
  close(iunit)


!!!! sample from RSF files (see manual page 271)  
  do i=1,nfiles
     open(junit,file=trim(names(i)),form='unformatted',status='old',access='stream',err=870,iostat=ios)
!!$      print*,'processing file ',trim(names(i))
     call read_header(junit,0)
     !print*,'read header'
     if(endfile)exit
!!$     print*,'number of heights',nhts
!!$     print*,'year, day, hour, minute:',jyear,jday,jhour,jmin
!!$     print*,'hstart,hstep:',hstart,hstep
     it=itime(jyear,jday,jhour,jmin)
     !print*,'reading '//trim(names(i)),it
     Ly=365
     if(mod(jyear,4).eq.0)Ly=366
     timearray(it,1)=jyear
     timearray(it,2)=jday
     timearray(it,3)=jhour
     timearray(it,4)=jmin
     !print*,'time index=',it
     if(jhour.eq.0..and.jmin.eq.0.)then
        print*,'day ',jday,'time index',it
        print'(A3,I2,A1,I2,A1,I2)','...',jdaymon,'/',jmonth,'/',jyear
     endif
     do
        do
           !print*,'fgroup'
           call read_frgroup(junit,0)
           !print*,'nsum=',nsum
           !stop
           if(imode.eq.0)goto 20 !there seem to be some padding records with subhdr==0
           if(jmode.ne.imode.and.jmode.ne.3)goto 20 !use both if jmode=3
!!!! binning
           gscl=10.**(-(basedb+float(igain)*3.)/20.) !assume iamps() are "amps" not "pwr"                      
           do ih=1,nsum
              amp=iamps(ih,1)
              if(msignl.eq.0)amp=amp-mps
              if(mscale.eq.0)amp=1.
              hstart=abs(hstart)
              do j=1,nf
                 if(fmhz.ge.frange(j,1).and. fmhz .lt. frange(j,2))then
                    ncount(it,ih,j)=ncount(it,ih,j)+1
                    bins(it,ih,j)=bins(it,ih,j)+amp*gscl
                 end if
              end do
           end do
20         continue
           if(finished)exit
        end do
        finished=.false.
        call read_header(junit,0)
        if(endfile)exit
     end do
     close(junit)
     endfile=.false.
  end do

  if(nsum.gt.nhts)then
     print*,'ERROR: nsum .gt. nhts',nsum,nhts
     stop
  end if
  
  print*,'finished sampling'

  call plotmaxima()
!  call plotheights()
  deallocate(maxheights)  
  deallocate(bins,ncount)

  
  
  goto 1000

!111 format(2f7.3,
!0.500 1175.0 -90  57  66   0.391 210.0  30.0 1187
700 print*,'error opening input'
  goto 1000

800 print*,'error opening fnames_list'
  goto 1000
  
870 print*,'error opening file '//trim(rsfname)
  goto 1000

  

1000 continue



CONTAINS


  

    subroutine plotmaxima()
    implicit none
    integer i,j,k,l,it,n,nn
    double precision maxsig,x,av,sigma,avt
    integer, allocatable :: ind(:),index(:)
    double precision, allocatable :: tempsig(:),xx(:),y(:,:),y2(:,:)
    character*2 A
    print*,'allocating array maxheights'
    allocate(maxheights(nt,nf,2),y(nt,nf),y2(nt,nf))
    print*,'allocated array maxheights'
    print*,'will plot maxima for ',nf,' ranges'
    do j=1,nf
       if(j.le.9)write(A,'(I1)')j
       if(j.gt.9)write(A,'(I2)')j
       open(1,file=trim(logo)//'_maxima_'//trim(A)//'.dat')
       print*,'creating '//trim(logo)//'_maxima_'//trim(A)//'.dat'
       !call filterbins(3,j)
       do it=1,nt
          nn=0
          do i=1,nsum
             x=abs(hstart)+(i-1.)*hstep
             if(x.ge.minh .and. x.le.maxh)then
                nn=nn+1
             end if
          end do
          allocate(ind(nn),tempsig(nn),xx(nn),index(nn))
          nn=0
          av=0.
          sigma=0.
          do i=1,nsum
             x=abs(hstart)+(i-1.)*hstep
             if(x.ge.minh .and. x.le.maxh)then
                nn=nn+1
                xx(nn)=x
                ind(nn)=i
                tempsig(nn)=bins(it,i,j)
                av=av+bins(it,i,j)
                sigma=sigma+bins(it,i,j)**2
             end if
          end do
          av=av/nn
          sigma=sqrt(sigma/nn-av**2)
          call sort2(nn,tempsig,ind)
          y(it,j)=0. ; y2(it,j)=0. 
          avt=0.
          do i=1,nmaxima
             x=abs(hstart)+(ind(nn-i+1)-1.)*hstep
             !x=xx(nn-i+1)
             y(it,j)=y(it,j)+x
             y2(it,j)=y2(it,j)+x**2
             avt=avt+tempsig(nn-i+1)
          end do
          y2(it,j)=sqrt(y2(it,j)/nmaxima-(y(it,j)/nmaxima)**2)
          avt=avt/nmaxima
          deallocate(ind,tempsig,xx,index)
       end do  !it loop
       do it=1,nt
          maxheights(it,j,1)=y(it,j)/nmaxima
          maxheights(it,j,2)=y2(it,j)
       end do
       call filter(3,j)
       do it=1,nt
          write(1,*)timearray(it,:),(it-1)*timestep/60.D0,maxheights(it,j,1),maxheights(it,j,2),timestep
       end do
       close(1)
    end do     !frequency loop
    deallocate(y,y2)
  end subroutine plotmaxima

  subroutine filter(order,ii)
    implicit none
    integer, intent(in) :: order,ii
    integer i,it,n
    double precision :: av,d,w,pi,sigma
    double precision, allocatable :: x(:)
    allocate(x(nt))
    pi=acos(-1.D0)
    sigma=3.
    do it=1,nt
       av=0.
       n=0
       do i=-order,order
          if(it+i .ge. 1 .and. it+i .le. nt)then
             n=n+1
             av=av+maxheights(it+i,ii,1)
          end if
       end do
       av=av/n
!!$       d=0.
!!$       do i=-order,order
!!$          if(it+i .ge. 1 .and. it+i .le. nt)then
!!$             w=exp(-(maxheights(it+i,ii,1)-av)**2/2./sigma**2)
!!$             d=d+w
!!$          end if
!!$       end do
!!$       x(it)=0.
       do i=-order,order
          if(it+i .ge. 1 .and. it+i .le. nt)then
!!$             w=exp(-(maxheights(it+i,ii,1)-av)**2/2./sigma**2)
!!$             x(it)=x(it)+maxheights(it+i,ii,1)*w/d
             x(it)=av
          end if
       end do
    end do
    maxheights(:,ii,1)=x
    deallocate(x)    
  end subroutine filter
  

  subroutine plotheights()
    implicit none
    integer :: i,j,k,it,n
    character*1 A
    character*2 B
    double precision, allocatable :: heightbins(:,:,:),norm(:)
    double precision :: x,y
    select case(nhts)
    case(512)
       n=501
    case(256)
       n=249
    case default
       print*,'error in plotheights, number of height not supported'
       stop
    end select
    allocate(heightbins(nt,n,nf),norm(n))
    heightbins=0.
    do j=1,nf
       if(j.le.9)then
          write(A,'(I1)')j
          open(1,file=trim(logo)//'_heights_'//A//'.dat')
       else
          write(B,'(I2)')j
          open(1,file=trim(logo)//'_heights_'//B//'.dat')
       end if
       do it=1,nt
          if(maxheights(it,j,1).gt.-10.)write(1,*)'#',timearray(it,:)
          do i=1,n
             x=abs(hstart)+(i-1.)*hstep
             if(x.ge.minh.and.x.le.maxh.and.maxheights(it,j,1).gt.-10.)write(1,*)x,bins(it,i,j)
          end do
          if(maxheights(it,j,1).gt.-10.)then
             write(1,*)
             write(1,*)
          end if
          y=0.
          k=0
          do i=1,n
             x=abs(hstart)+(i-1.)*hstep
             if(x.ge.minh.and.x.le.maxh.and.maxheights(it,j,1).gt.-10.)then
                y=y+bins(it,i,j)
                k=k+1
             end if
          end do
          do i=1,n
             x=abs(hstart)+(i-1.)*hstep
             if(x.ge.minh.and.x.le.maxh.and.maxheights(it,j,1).gt.-10.) &
                  heightbins(it,i,j)=bins(it,i,j)-y/k
          end do
       end do
       close(1)
       if(j.le.9)then
          write(A,'(I1)')j
          open(1,file=trim(logo)//'_heightbins_'//A//'.dat')
       else
          write(B,'(I2)')j
          open(1,file=trim(logo)//'_heightbins_'//B//'.dat')
       end if
       do it=1,nt
          do i=1,n
             x=abs(hstart)+(i-1.)*hstep
             if(x.ge.minh.and.x.le.maxh.and.maxheights(it,j,1).gt.-10.) &
                  write(1,*)(it-1)*timestep/60.,x,heightbins(it,i,j)
          end do
       end do
       close(1)
    end do
    deallocate(heightbins,norm)
  end subroutine plotheights

  
  
  subroutine plotavheights()
    implicit none
    integer :: i,ii,j,k,it,n
    double precision :: av
    character*2 A
    select case(nhts)
    case(512)
       n=501
    case(256)
       n=249
    case default
       print*,'error in plotavheights, number of height not supported'
       stop
    end select
    do j=1,nf
       if(j.le.9)write(A,'(I1)')j
       if(j.gt.9)write(A,'(I2)')j
       open(1,file=trim(logo)//'_avheights_'//trim(A)//'.dat')
       do it=1,nt
          write(1,*)'#',timearray(it,:)
          ii=0 ; av=0.
          do i=1,n
             ii=ii+1
             av=av+bins(it,i,j)
             if(ii==avh)then
                x=abs(hstart)+(i-1.-avh/2)*hstep
                if(x.ge.minh.and.x.le.maxh)write(1,*)x,av/avh
                ii=0 ; av=0.
             end if
          end do
          write(1,*)
          write(1,*)
       end do
       close(1)
    end do
  end subroutine plotavheights

    

   integer function itime(jyear,jday,jhour,jmin)
    implicit none
    integer, intent(in) :: jyear,jday,jhour,jmin
    real x,y,m,h,d
    itime=1
    m=minutemin
    h=hourmin
    d=daymin
    y=yearmin
    !print*,y,d,h,m
    !print*,jyear,jday,jhour,jmin
    if(jyear==int(y) .and. jday==int(d) .and. jhour==int(h) .and. jmin==int(m))return
    do
       m=m+timestep
       if(m.gt.60.-timestep)then
          m=0.
          h=h+1.
       end if
       if(h.gt.23)then
          h=0.
          d=d+1
       end if
       if(d.gt.Ly)then
          d=1
          y=y+1
          Ly=365
          if(mod(int(y),4).eq.0)Ly=366
       end if
       itime=itime+1
!!$       if(itime.gt.nt.and..not.first)then
!!$          print*,'logical error in itime',y,d,h,m,itime
!!$          stop
!!$       end if
       !print*,y,d,h,m,itime,'-----------',jyear,jday,jhour,jmin
       !print*,m,h,d,y
       if(jyear==int(y) .and. jday==int(d) .and. jhour==int(h) .and. jmin==int(m))exit 
    end do
    return
  end function itime


  
  SUBROUTINE READ_HEADER(UNIT,iprint)
    IMPLICIT NONE
    integer, intent(in) :: unit,iprint

    integer*1 in256(256),in498(498),in1002(1002)
    character*40 fname
    character*128 direct
    character*3 astn,atxid,arxid
    character*60 aheader,ahdrL
    INTEGER*1 IHEADER(60),subhdr(6),byte
    integer*1 ios,istn,ibcd(60),i4hdr(60) 
    integer*2 ii

    integer k
    integer ioff,ibgndb
    integer kmstep,idfrmt
    integer kmstart
    
    equivalence (byte,ii),(iheader(1),aheader)
    !equivalence (iheader(1),aheader)

    
    read(unit,iostat=ios,end=1000,err=900)iheader
    if(iprint.ne.0)print*,'=========================='
    !print*,iheader
    if(iprint.ne.0)print*,'header:'!,iheader
    if(iprint.ne.0)write(*,'(1x,8(1x,4z2),/,1x,8(1x,4Z2))')iheader
      !c... convert header into nybbles and bcd      
    do k=1,60
       ii=iheader(k)
       i4hdr(k)=ii
       ibcd(k)=(ii/16)*10+mod(ii,16)
    enddo
    if(iprint.ne.0)print*,'=========================='
    if(iprint.ne.0)print'('' header:ibcd='',1x,20i3,/,1x,20i3,/,1x,20i3)',ibcd
!    stop
!!$    ibcd=(iheader/16)*10+mod(iheader,16)
    !print*,'ibcd:',ibcd
    ioff=3 !real data are offset from table 6-3 by 3 bytes
    jyear=ibcd(1+ioff)
    jday=ibcd(2+ioff)*100+ibcd(3+ioff)
    jmonth=ibcd(4+ioff)
    jdaymon=ibcd(5+ioff)
    !print*,'############# jday test',jday,ibcd(2+ioff),ibcd(3+ioff)
    !print*,jmonth,jdaymon
    k=julian(jyear,jmonth,jdaymon)
    if(k.ne.jday)jday=k
    !    stop
    jhour=ibcd(6+ioff)
    jmin=ibcd(7+ioff)
    jsec=ibcd(8+ioff)
    nhts=ibcd(36+ioff)*100+ibcd(37+ioff)
    if(iprint.ne.0)print*,'year,day,month:',jyear,jday,jmonth
    if(iprint.ne.0)print*,'hour,min,sec:',jhour,jmin,jsec
    !if(iprint==0)return ! just for reading the file headers for min/max time count
    !write(3,*)'year,day,month:',jyear,jday,jmonth
    !write(3,*)'hour,min,sec:',jhour,jmin,jsec
    arxid=aheader(9+ioff:11+ioff)
    atxid=aheader(12+ioff:14+ioff)
    if(iprint.ne.0)print*,'arxid,atxid: ',arxid,' ',atxid
!c...ALL IN MHz      
    frq1st=((ibcd(17+ioff)*100+ibcd(18+IOFF))*100+IBCD(19+IOFF))/10000. 
    fcstep=(IBCD(20+IOFF)*100+IBCD(21+IOFF))*0.001 
    frqLst=( (ibcd(22+ioff)*100+ibcd(23+IOFF))*100+IBCD(24+IOFF))/10000.
    ffstep=(ibcd(25+ioff)*100+ibcd(26))*0.001
    if(iprint.ne.0)print*,'start,stop frequency (MHz):',frq1st,frqLst
    if(iprint.ne.0)print*,'coarse/fine frequency steps(MHz):',fcstep,ffstep
    !write(3,*)'start,stop frequency (MHz):',frq1st,frqLst
    !write(3,*)'coarse/fine frequency steps(MHz):',fcstep,ffstep
    kmstart=(ibcd(33+ioff)*100+ibcd(34+ioff))
    !print*,'kmstart',(ibcd(33+ioff)*100+ibcd(34+ioff))
    !print*,'kmstart',ibcd(33+ioff),ibcd(34+ioff)
    !print*,'kmstart',kmstart
    !stop
    kmstep=ibcd(35+ioff) !2=2.5, 5=5km, 10=10km
    !stop
    if(iprint.ne.0)print*,ibcd(33+ioff),ibcd(34+ioff),kmstart
    hstart=real(kmstart)
    hstep=5*(ibcd(35+ioff)/5.) !2=2.5, 5=5km, 10=10km
    if(kmstep.eq.2)hstep=2.5
    !if(ibcd(35+ioff).eq.2)hstep2=2.5
    if(iprint.ne.0)print*,'starting height (km)',hstart
    if(iprint.ne.0)print*,'height step',hstep
    if(iprint.ne.0)print*,'number of heights:',nhts
    !write(3,*)'starting height (km)',hstart
    !write(3,*)'height step',hstep
    !write(3,*)'number of heights:',nhts
    idfrmt=ibcd(43+ioff)
    if(idfrmt.ne.4)then
       print*,'header says this is not .rsf format !'
       !print'('' header:ibcd='',1x,20i3,/,1x,20i3,/,1x,20i3)',ibcd
       stop
    endif
    basedb=0.
    ibgndb=ibcd(40+ioff)
    if(ibgndb.lt.8)basedb=ibgndb*6

    return

900 continue
    print*,'error while reading header'
    stop
    
1000 continue

!!$    print*,'end of file'
    endfile=.true.
    
    return
    
  END SUBROUTINE READ_HEADER

  integer function julian(y,m,d)
    implicit none
    integer, intent(in) :: y,m,d
    integer :: i,months(12)
    months=(/31,28,31,30,31,30,31,30,31,30,31,30/)    
    if(mod(y,4).eq.0)months(2)=29
    julian=0
    do i=1,m-1
       julian=julian+months(i)
    end do
    julian=julian+d
  end function julian
  

  subroutine read_frgroup(unit,iprint)
    implicit none
    integer, intent(in) ::unit,iprint
    integer i,jj,ih,nn,jjmin,jjmax,mpv,kz,num,nmbr
    integer*1 subhdr(6),byte,test(4)
    integer*1, allocatable :: inxxx(:)
    integer :: icall=0

    integer*2 ii

    equivalence (byte,ii)

    
    !
    icall=icall+1 !frequency group number
    !print*,'icall',icall
    select case(nhts)
    case(128)
       if(icall.gt.15)then
          finished=.true.
           icall=0
          read(unit)(byte,i=1,106) !skip padding
          return
       endif
       allocate(inxxx(256))
       nn=128
    case(256)
       if(icall.gt.8)then
          finished=.true.
           icall=0
          read(unit)(byte,i=1,4) !skip padding
          return
        endif  
        allocate(inxxx(498))
        nn=249
     case(512)
        if(icall.gt.4)then 
           finished=.true.
           icall=0
           read(unit)test !(byte,i=1,4) !skip padding
           return
        endif
        allocate(inxxx(1002))
        nn=501
     case default
        print*,'undefined option in read_frgroup',nn
        stop
     end select
     read(unit,end=1000,err=900,iostat=ios)subhdr,inxxx
     ii=0
     byte=subhdr(2)
     fmhz=(ii/16)*10+mod(ii,16)
     byte=subhdr(3)
     fmhz=fmhz+((ii/16)*10+mod(ii,16))*0.01
     imode=ii/16-1 !1=Xmode, 2=Omode
     byte=subhdr(6)
     mps=(ii/16)*10+mod(ii,16)
     byte=subhdr(4)
     igain=mod(ii,16)
     jjmin=9999999
     jjmax=-999999
     do kz=1,32  !replace mps for test
        mpvamp(kz)=0
     enddo
     do ih=1,nn !see program of CMEEK
        byte=inxxx(ih*2-1)
        iamps(ih,1)=ii/8 ! amp
        jj=ii/8
        if(jj.lt.jjmin)jjmin=jj
        if(jj.gt.jjmax)jjmax=jj
        mpvamp(jj+1)=mpvamp(jj+1)+1
        iamps(ih,2)=mod(ii,8)   !dop
        byte=inxxx(ih*2)
        iamps(ih,3)=ii/8 !phase
        iamps(ih,4)=mod(ii,8)
     enddo
     mpv=1
     nmbr=mpvamp(1)
     do kz=2,32
        num=mpvamp(kz)
        if(num.gt.nmbr)then
           nmbr=num
           mpv=kz
        endif
     enddo
     mps=mpv-1
     nsum=nn
     if(iprint.ne.0)write(*,8841)fmhz,imode,mps,igain,jjmin,jjmax
8841 format('SubHdrParms:fMhz,X1/O2,mps,gain sigmn/mx:',&
         f6.2,i2,1x,i4,i3,2i7)

     if(iprint.ne.0)print*,'frequency group was read. icall=',icall
     deallocate(inxxx)
     return
     
900 continue
    print*,'error while reading frequency group'
    stop
    
1000 continue
    print*,'unexpected end of frequency group'
    stop
    
  end subroutine read_frgroup





  
end program readRSF

subroutine localmaxima(x,y,index,n,thresh)
  implicit none
  integer :: i,j,k,kk,n,n1,n2
  double precision :: y(n),x(n),z,av,std,a,b,r,l,thresh
  integer :: index(n)
  index=0
  k=5
  kk=n
  call fit(x,y,n,a,b)
  av=0.
  std=0.
  do i=1,n
     y(i)=y(i)-a-b*x(i)
     av=av+y(i)/n
     std=std+y(i)**2/n
  end do
  std=sqrt(std-av**2)
  do i=1,n
     r=0.
     n1=0
     do j=i+k,i+kk
        if(j.ge.1 .and. j.le.n)then
           r=r+y(j)
           n1=n1+1
        end if
     end do
     if(n1.gt.0)r=r/n1
     l=0.
     n2=0
     do j=i-kk,i-k
        if(j.ge.1 .and. j.le.n)then
           l=l+y(j)
           n2=n2+1
        end if
     end do
     if(n2.gt.0)l=l/n2
     z=0.
     if(n1.gt.0)z=z+y(i)-r
     if(n2.gt.0)z=z+y(i)-l
     if(n1.gt.0 .and. n2.gt.0)z=z/2.
     if(z.gt.(thresh*std))index(i)=1
  end do
end subroutine localmaxima


 SUBROUTINE SORT2(N,RA,RB)
       ! Heapsort routine from "Numerical Recipes" ch. 8.3, p327
       implicit none 
       real*8 RA(N), rra
       integer RB(N), rrb
       integer l, ir, i, j, n
       L=N/2+1
       IR=N
10     CONTINUE
       IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
       ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
             RA(1)=RRA
             RB(1)=RRB
             RETURN
          ENDIF
       ENDIF
       I=L
       J=L+L
20     IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
             IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
             RA(I)=RA(J)
             RB(I)=RB(J)
             I=J
             J=J+J
          ELSE
             J=IR+1
          ENDIF
          GO TO 20
       ENDIF
       RA(I)=RRA
       RB(I)=RRB
       GO TO 10
     END SUBROUTINE SORT2

 SUBROUTINE ISORT(N,RA,RB)
       ! Heapsort routine from "Numerical Recipes" ch. 8.3, p327
       implicit none 
       integer RA(N), rra
       integer RB(N), rrb
       integer l, ir, i, j, n
       L=N/2+1
       IR=N
10     CONTINUE
       IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
       ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
             RA(1)=RRA
             RB(1)=RRB
             RETURN
          ENDIF
       ENDIF
       I=L
       J=L+L
20     IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
             IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
             RA(I)=RA(J)
             RB(I)=RB(J)
             I=J
             J=J+J
          ELSE
             J=IR+1
          ENDIF
          GO TO 20
       ENDIF
       RA(I)=RRA
       RB(I)=RRB
       GO TO 10
     END SUBROUTINE ISORT


     SUBROUTINE fit(x,y,ndata,a,b) !,siga,sigb,chi2,q)
       INTEGER mwt,ndata
       double precision :: a,b,chi2,q,siga,sigb,x(ndata),y(ndata)
       !USES gammq
       !Given a set of data points x(1:ndata) , y(1:ndata) with individual standard deviations
       !sig(1:ndata) , fit them to a straight line y = a + bx by minimizing χ 2 . Returned are
       !a,b and their respective probable uncertainties siga and sigb , the chi-square chi2 , and
       !the goodness-of-fit probability q (that the fit would have χ 2 this large or larger). If mwt=0
       !on input, then the standard deviations are assumed to be unavailable: q is returned as 1.0
       !and the normalization of chi2 is to unit standard deviation on all points.
       INTEGER i
       double precision :: sigdat,ss,st2,sx,sxoss,sy,t,wt
       sx=0.
       !Initialize sums to zero.
       sy=0.
       st2=0.
       b=0.
       do i=1,ndata
          !...or without weights.
          sx=sx+x(i)
          sy=sy+y(i)
       enddo
       ss=float(ndata)
       sxoss=sx/ss
       do i=1,ndata
          t=x(i)-sxoss
          st2=st2+t*t
          b=b+t*y(i)
       enddo
       b=b/st2
       !Solve for a, b, σ a , and σ b .
       a=(sy-sx*b)/ss
       return
       siga=sqrt((1.+sx*sx/(ss*st2))/ss)
       sigb=sqrt(1./st2)
       chi2=0.
       do i=1,ndata
          chi2=chi2+(y(i)-a-b*x(i))**2
       enddo
       q=1.
       sigdat=sqrt(chi2/(ndata-2))
       !For unweighted data evaluate typical sig using chi2,
       siga=siga*sigdat
       !and adjust the standard deviations.
       sigb=sigb*sigdat
       return
     END SUBROUTINE fit

